/*******************************************************************************
 *
 * File Name: neuralNetworkBiologicalConstructs.cpp
 * Author: Richard Baxter
 * Project: Advanced Neural Network (ANN) - Fractal Based Neural Network
 * Project Version: 1b20b 12-Oct-07
 * Comments: NB CHECK THIS new requirement; each subnet must have at least 3 layers
 *			how to record movement information? how to get synthetic network to modify its focus; left, right, in, out towards the objects of most interest?
 *******************************************************************************/

#include <ctime>
#include <cstdlib>	//for randon number generation
#include <cmath>

#include <string>
#include <iostream>
#include <fstream>
using namespace std;


#include "neuralNetworkFormation.h"
#include "neuralNetworkTraining.h"


//#include "unknownProjectData.h"
#include "neuralNetworkBiologicalConstructs.h"


//pseudo code only
void formNeuralNetworkBiologicalConstructs()
{
	//this function is useless without some real data, however it should be pretty clear as to its usage once a data feed can be established (Eg with a robot)

	Neuron * firstNeuronInVisualCortexSubnet = new Neuron();
	formVisualCortexSubnet(firstNeuronInVisualCortex);

	Neuron * firstNeuronInAudialCentreSubnet = new Neuron();
	formAudialCentreSubnet(firstNeuronInAudialCentreSubnet);

	Neuron * firstNeuronInSyntheticBrainSubnet = new Neuron();
	formSyntheticBrainSubnet(firstNeuronInSyntheticBrainSubnet, firstNeuronInVisualCortexSubnet, firstNeuronInAudialCentreSubnet);

}

void formVisualCortexSubnet(Neuron * firstNeuronInVisualCortexSubnet)
{
	Neuron * firstNeuronInLeftEyeVisualFieldSubnet = new Neuron();
	Neuron * firstNeuronInRightEyeVisualFieldSubnet = new Neuron();
	Neuron * firstNeuronInFocusDistanceSubnet = new Neuron();			//single input neuron identifying the current focus distance of the eyes (effects 1-1 mapping of L/R eye data)
	Neuron * firstNeuronInParallaxRecognitionSubnet = new Neuron();
	Neuron * firstNeuronInObjectRecognitionSubnet = new Neuron();

	form2dVisualFieldSubnet(firstNeuronInLeftEyeVisualFieldSubnet, NUMBER_OF_HORIZONTAL_PIXELS_TH, NUMBER_OF_VERTICAL_PIXELS_TH);
	form2dVisualFieldSubnet(firstNeuronInRightEyeVisualFieldSubnet, NUMBER_OF_HORIZONTAL_PIXELS_TH, NUMBER_OF_VERTICAL_PIXELS_TH);

	formParallaxRecognitionSubnet(firstNeuronInParallaxRecognitionSubnet, firstNeuronInLeftEyeVisualFieldSubnet, firstNeuronInRightEyeVisualFieldSubnet, firstNeuronInFocusDistanceSubnet);
	formObjectRecognitionSubnet(firstNeuronInLeftEyeVisualFieldSubnet, NUMBER_OF_OBJECT_RECOGNITION_HORIZONTAL_PIXELS_TH, NUMBER_OF_OBJECT_RECOGNITION_VERTICAL_PIXELS_TH);


	//NOW.. to form firstNeuronInVisualCortexSubnet, add the formParallaxRecognitionSubnet and the firstNeuronInObjectRecognitionSubnet in parallel (on a single layer) and have their outputs mixed on the next layer?

}

void formParallaxRecognitionSubnet(Neuron * firstNeuronInParallaxRecognitionSubnet, Neuron * firstNeuronInLeftEyeVisualFieldSubnet, Neuron * firstNeuronInRightEyeVisualFieldSubnet, Neuron * firstNeuronInFocusDistanceSubnet)
{
	//NOW.. to formParallaxRecognitionSubnet, connect the low level neurons of each eye, if the neural network recognises the same information in all kernels (Eg 10x10 pixel groups) of each eye, it is assumed an object has been focused, and its distance can be determined based upon the current focal distance of the eyes
}

void formSyntheticBrainSubnet(Neuron * firstNeuronInSyntheticBrainSubnet, Neuron * firstNeuronInVisualCortexSubnet, Neuron * firstNeuronInAudialCentreSubnet)
{
	//NOW.. to formfirstNeuronInSyntheticBrainSubnet, add the firstNeuronInVisualCortexSubnet and firstNeuronInAudialCentreSubnet in parallel (on a single layer) and have their outputs mixed on the next layer
}

void form2dVisualFieldSubnet(Neuron * firstNeuronInVisualFieldSubnet, long visualArrayWidth, long visualArrayHeight)
{
	//NOW.. to form2dVisualFieldSubnet, form a network such that each input neuron (cone/rod/pixel) is first connected to neighboring input neurons in the 2D field, enabling contrast recognition and object outline angles to be determined.

	numOutputNeurons >> numInputNeurons
}

void formObjectRecognitionSubnet(Neuron * firstNeuronInEyeVisualFieldSubnet, long objectRecognitionVisualArrayWidth, long objectRecognitionVisualArrayHeight)
{
	//NOW.. to formObjectRecognitionSubnet, take the central section of the visual field, and form a dense complex network
}


		//in higher layers in the visual cortex, this low level information is then brought together in higher layers to store memory of certain shapes/objects in the network.
			//object recognition should  be performed primarily on the central visual field neurons. movement detection should be performed primarily on the outer visual field neurons
