/*******************************************************************************
 *
 * File Name: neuronClass.cpp
 * Author: Richard Baxter
 * Project: Advanced Neural Network (ANN) - Fractal Based Neural Network
 * Project Version: 1b20b 12-Oct-07
 * Comments: NB CHECK THIS new requirement; each subnet must have at least 3 layers
 *
 *******************************************************************************/

 //IMPORTANT CODING NOTE - on 10-dec-06/1b6b I have started to remove the neuronReference class as circular referencing does not appear to be allowed in C++
//NB when create NeuronList class change all referecnes to "...List->frontNeuronReferences.." to "...List->neuronReferences"

#include "neuronClass.h"

/************************************************************ Neural Network Class Definitions ******************************************************/

#include <ctime>
#include <cstdlib>	//for randon number generation
#include <cmath>

#include <string>
#include <iostream>
#include <fstream>
using namespace std;



Neuron::Neuron(void)
{
	//Define default values for neuron relations


	numFrontNeuronConnections = 0;
	numBackNeuronConnections = 0;

	id = 0;			//none = 0
	orderID = 0;	//none = 0
	layerID = 0;	//none = 0
	subnetID = 0;	//none = 0

	nextNeuron = NULL;
	previousNeuron = NULL;

	//old terms;
	//currentFrontNeuronReference = 0;
	//currentBackNeuronReference = 0;

	//new terms;

	hasFrontLayer = false;
	hasBackLayer = false;
	firstNeuronInFrontLayer = NULL;	//new - required
	firstNeuronInBackLayer = NULL;	//new - required


#ifdef ANN
	isSubnet = false;
	firstNeuronInBackLayerOfSubnet = NULL;
	numNeuronsInBackLayerOfSubnet = 0;
#endif

}


Neuron::Neuron(long IDInit, long orderIDInit, long layerIDInit, long subnetIDInit)
{
	id = IDInit;
	orderID = orderIDInit;
	layerID = layerIDInit;
	subnetID = subnetIDInit;

	//Define default values for neuron relations

	numFrontNeuronConnections = 0;
	numBackNeuronConnections = 0;

	nextNeuron = NULL;
	previousNeuron = NULL;

	//old terms;
	//currentFrontNeuronReference = 0;
	//currentBackNeuronReference = 0;

	//new terms;

	hasFrontLayer = false;
	hasBackLayer = false;
	firstNeuronInFrontLayer = NULL;	//new - required
	firstNeuronInBackLayer = NULL;	//new - required


#ifdef ANN
	isSubnet = false;
	firstNeuronInBackLayerOfSubnet = NULL;
	numNeuronsInBackLayerOfSubnet = 0;
#endif

}




Neuron::~Neuron(void)
{

}

NeuronConnection::NeuronConnection(void)
{

}

NeuronConnection::~NeuronConnection(void)
{

}


void copyNeuronKeyProperties(Neuron * neuronToUpdate, Neuron * neuronToCopy)
{
	neuronToUpdate->bias = neuronToCopy->bias;
	neuronToUpdate->storedBias = neuronToCopy->storedBias;
	neuronToUpdate->output = neuronToCopy->output;
	neuronToUpdate->classTarget = neuronToCopy->classTarget;
	neuronToUpdate->error = neuronToCopy->error;

}

/************************************************************ End Neural Network Class Definitions **************************************************/


